nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
nx::sdk::analytics::IIntegration Class Referenceabstract

`#include <i_integration.h>`

Inheritance diagram for nx::sdk::analytics::IIntegration:

## Public Member Functions
Result< const IString * > | manifest () const
Result< IEngine * > | createEngine ()
Public Member Functions inherited from nx::sdk::Interface< IIntegration, nx::sdk::IIntegration0 >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IIntegration
virtual void | setUtilityProvider (IUtilityProvider *utilityProvider)=0
Public Member Functions inherited from nx::sdk::Interface< IIntegration >
virtual IRefCountable * | queryInterface (const InterfaceId *id)
Ptr< Interface > | queryInterface ()
Ptr< const Interface > | queryInterface () const
Public Member Functions inherited from nx::sdk::IRefCountable
virtual | ~IRefCountable ()=default
template<class Interface >
Ptr< Interface > | queryInterface ()
template<class Interface >
Ptr< const Interface > | queryInterface () const
virtual int | addRef () const =0
virtual int | releaseRef () const =0
int | refCountThreadUnsafe () const

## Static Public Member Functions
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IIntegration
static auto | interfaceId ()
Static Public Member Functions inherited from nx::sdk::IRefCountable
static auto | interfaceId ()

## Protected Member Functions
virtual void | getManifest (Result< const IString *> *outResult) const =0
virtual void | doCreateEngine (Result< IEngine *> *outResult)=0
Protected Member Functions inherited from nx::sdk::Interface< IIntegration, nx::sdk::IIntegration0 >
virtual IRefCountable * | queryInterface (const IRefCountable::InterfaceId *id) override
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)
Protected Member Functions inherited from nx::sdk::Interface< IIntegration >
IRefCountable * | queryInterfaceSupportingDeprecatedId (const IRefCountable::InterfaceId *id, const Uuid &deprecatedInterfaceId)

## Additional Inherited Members
Static Protected Member Functions inherited from nx::sdk::IRefCountable
template<int len>
static const InterfaceId * | makeId (const char(&charArray)[len])
template<int len, int alternativeLen>
static std::vector< const InterfaceId * > | makeIdWithAlternative (const char(&charArray)[len], const char(&alternativeCharArray)[alternativeLen])
template<class TemplateInstance , class TemplateArg , int len>
static const InterfaceId * | makeIdForTemplate (const char(&baseIdCharArray)[len])
static std::vector< const InterfaceId * > | alternativeInterfaceIds (const InterfaceId *id)
static std::vector< const InterfaceId * > | alternativeInterfaceIds (std::vector< const InterfaceId *> ids)

## Detailed Description

The main interface for an Analytics Plugin instance.

## Member Function Documentation

## ◆ createEngine()

Result<IEngine*> nx::sdk::analytics::IIntegration::createEngine | ( |  | ) |
| inline

Creates a new instance of Analytics Engine.

Returns
  Pointer to an object that implements the IEngine interface.

## ◆ doCreateEngine()

virtual void nx::sdk::analytics::IIntegration::doCreateEngine | ( | Result< IEngine *> * | outResult | ) |
| protectedpure virtual

Called by createEngine()

## ◆ getManifest()

virtual void nx::sdk::analytics::IIntegration::getManifest | ( | Result< const IString *> * | outResult | ) | const
| protectedpure virtual

Called by manifest()

## ◆ manifest()

Result<const IString*> nx::sdk::analytics::IIntegration::manifest | ( |  | ) | const
| inline

Provides Plugin Manifest in JSON format.

See the manifest specification in Analytics Integration Manifests.

Returns
  JSON string in UTF-8.

The documentation for this class was generated from the following file:

- src/nx/sdk/analytics/i_integration.h